]> git.ipfire.org Git - thirdparty/git.git/blame - git-submodule.sh
server-info: clean up after writing info/packs
[thirdparty/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
4c8a9db6 3# git-submodule.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
681b036f 8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 10 or: $dashless [--quiet] init [--] [<path>...]
cf419828 11 or: $dashless [--quiet] deinit [-f|--force] [--] <path>...
893a9764 12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--reference <repository>] [--recursive] [--] [<path>...]
adc54235 13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 14 or: $dashless [--quiet] foreach [--recursive] <command>
82f49f29 15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
8f321a39 16OPTIONS_SPEC=
091a6eb0 17SUBDIRECTORY_OK=Yes
70c7ac22 18. git-sh-setup
d0ad8251 19. git-sh-i18n
98fcf840 20. git-parse-remote
70c7ac22 21require_work_tree
091a6eb0
JK
22wt_prefix=$(git rev-parse --show-prefix)
23cd_to_toplevel
70c7ac22 24
5c08dbbd 25command=
ecda0723 26branch=
d27b876b 27force=
d92a3959 28reference=
70c7ac22 29cached=
48bb3033
GP
30recursive=
31init=
1c244f6e 32files=
06b1abb5 33remote=
31ca3ac3 34nofetch=
32948425 35update=
15fc56a8 36prefix=
73b0898d 37custom_name=
275cd184 38depth=
70c7ac22 39
967b2c66
JS
40# The function takes at most 2 arguments. The first argument is the
41# URL that navigates to the submodule origin repo. When relative, this URL
42# is relative to the superproject origin URL repo. The second up_path
43# argument, if specified, is the relative path that navigates
44# from the submodule working tree to the superproject working tree.
45#
46# The output of the function is the origin URL of the submodule.
47#
48# The output will either be an absolute URL or filesystem path (if the
49# superproject origin URL is an absolute URL or filesystem path,
50# respectively) or a relative file system path (if the superproject
51# origin URL is a relative file system path).
52#
53# When the output is a relative file system path, the path is either
54# relative to the submodule working tree, if up_path is specified, or to
55# the superproject working tree otherwise.
f31a522a
ML
56resolve_relative_url ()
57{
98fcf840 58 remote=$(get_default_remote)
8e7e6f39 59 remoteurl=$(git config "remote.$remote.url") ||
4d689320 60 remoteurl=$(pwd) # the repository is its own authoritative upstream
f31a522a 61 url="$1"
99b120af 62 remoteurl=${remoteurl%/}
ea640cc6 63 sep=/
967b2c66
JS
64 up_path="$2"
65
66 case "$remoteurl" in
67 *:*|/*)
68 is_relative=
69 ;;
758615e2
JS
70 ./*|../*)
71 is_relative=t
72 ;;
967b2c66
JS
73 *)
74 is_relative=t
758615e2 75 remoteurl="./$remoteurl"
967b2c66
JS
76 ;;
77 esac
78
f31a522a
ML
79 while test -n "$url"
80 do
81 case "$url" in
82 ../*)
83 url="${url#../}"
ea640cc6
TR
84 case "$remoteurl" in
85 */*)
86 remoteurl="${remoteurl%/*}"
87 ;;
88 *:*)
89 remoteurl="${remoteurl%:*}"
90 sep=:
91 ;;
92 *)
758615e2
JS
93 if test -z "$is_relative" || test "." = "$remoteurl"
94 then
95 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
96 else
97 remoteurl=.
98 fi
ea640cc6
TR
99 ;;
100 esac
f31a522a
ML
101 ;;
102 ./*)
103 url="${url#./}"
104 ;;
105 *)
106 break;;
107 esac
108 done
758615e2
JS
109 remoteurl="$remoteurl$sep${url%/}"
110 echo "${is_relative:+${up_path}}${remoteurl#./}"
f31a522a
ML
111}
112
091a6eb0
JK
113# Resolve a path to be relative to another path. This is intended for
114# converting submodule paths when git-submodule is run in a subdirectory
115# and only handles paths where the directory separator is '/'.
116#
117# The output is the first argument as a path relative to the second argument,
118# which defaults to $wt_prefix if it is omitted.
119relative_path ()
120{
121 local target curdir result
122 target=$1
123 curdir=${2-$wt_prefix}
124 curdir=${curdir%/}
125 result=
126
127 while test -n "$curdir"
128 do
129 case "$target" in
130 "$curdir/"*)
131 target=${target#"$curdir"/}
132 break
133 ;;
134 esac
135
136 result="${result}../"
137 if test "$curdir" = "${curdir%/*}"
138 then
139 curdir=
140 else
141 curdir="${curdir%/*}"
142 fi
143 done
144
145 echo "$result$target"
146}
147
a7b3269c
DA
148#
149# Get submodule info for registered submodules
150# $@ = path to limit submodule list
151#
152module_list()
153{
091a6eb0 154 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
be9d0a3a 155 (
74671241 156 git ls-files -z --error-unmatch --stage -- "$@" ||
be9d0a3a
HV
157 echo "unmatched pathspec exists"
158 ) |
fcb06a8d 159 @@PERL@@ -e '
313ee0d6
NMC
160 my %unmerged = ();
161 my ($null_sha1) = ("0" x 40);
be9d0a3a
HV
162 my @out = ();
163 my $unmatched = 0;
74671241 164 $/ = "\0";
313ee0d6 165 while (<STDIN>) {
be9d0a3a
HV
166 if (/^unmatched pathspec/) {
167 $unmatched = 1;
168 next;
169 }
313ee0d6
NMC
170 chomp;
171 my ($mode, $sha1, $stage, $path) =
172 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
173 next unless $mode eq "160000";
174 if ($stage ne "0") {
175 if (!$unmerged{$path}++) {
be9d0a3a 176 push @out, "$mode $null_sha1 U\t$path\n";
313ee0d6
NMC
177 }
178 next;
179 }
be9d0a3a
HV
180 push @out, "$_\n";
181 }
182 if ($unmatched) {
183 print "#unmatched\n";
184 } else {
185 print for (@out);
313ee0d6
NMC
186 }
187 '
a7b3269c
DA
188}
189
be9d0a3a
HV
190die_if_unmatched ()
191{
192 if test "$1" = "#unmatched"
193 then
194 exit 1
195 fi
196}
197
88ce00c3
TK
198#
199# Print a submodule configuration setting
200#
201# $1 = submodule name
202# $2 = option name
203# $3 = default value
204#
205# Checks in the usual git-config places first (for overrides),
206# otherwise it falls back on .gitmodules. This allows you to
207# distribute project-wide defaults in .gitmodules, while still
208# customizing individual repositories if necessary. If the option is
209# not in .gitmodules either, print a default value.
210#
211get_submodule_config () {
212 name="$1"
213 option="$2"
214 default="$3"
215 value=$(git config submodule."$name"."$option")
216 if test -z "$value"
217 then
218 value=$(git config -f .gitmodules submodule."$name"."$option")
219 fi
220 printf '%s' "${value:-$default}"
221}
222
223
941987a5
LH
224#
225# Map submodule path to submodule name
226#
227# $1 = path
228#
229module_name()
230{
537601ac 231 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
64394e3a 232 sm_path="$1"
fe22e542 233 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
a5099bb4 234 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
537601ac 235 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
1e42258a 236 test -z "$name" &&
64394e3a 237 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$sm_path'")"
6a066230 238 printf '%s\n' "$name"
941987a5 239}
33aa6fff
LH
240
241#
242# Clone a submodule
243#
9adfc1cf
TK
244# $1 = submodule path
245# $2 = submodule name
246# $3 = URL to clone
247# $4 = reference repository to reuse (empty for independent)
248# $5 = depth argument for shallow clones (empty for deep)
249#
23a485e3 250# Prior to calling, cmd_update checks that a possibly existing
ecda0723 251# path is not a git repository.
23a485e3 252# Likewise, cmd_add checks that path does not exist at all,
ecda0723
SV
253# since it is the location of a new submodule.
254#
33aa6fff
LH
255module_clone()
256{
64394e3a 257 sm_path=$1
73b0898d
JL
258 name=$2
259 url=$3
260 reference="$4"
275cd184 261 depth="$5"
7e60407f
JL
262 quiet=
263 if test -n "$GIT_QUIET"
264 then
265 quiet=-q
266 fi
33aa6fff 267
501770e1
FG
268 gitdir=
269 gitdir_base=
69c30517 270 base_name=$(dirname "$name")
33aa6fff 271
501770e1 272 gitdir=$(git rev-parse --git-dir)
69c30517
JL
273 gitdir_base="$gitdir/modules/$base_name"
274 gitdir="$gitdir/modules/$name"
501770e1
FG
275
276 if test -d "$gitdir"
d92a3959 277 then
64394e3a 278 mkdir -p "$sm_path"
501770e1 279 rm -f "$gitdir/index"
d92a3959 280 else
501770e1 281 mkdir -p "$gitdir_base"
be8779f7
DG
282 (
283 clear_local_git_env
275cd184 284 git clone $quiet ${depth:+"$depth"} -n ${reference:+"$reference"} \
be8779f7
DG
285 --separate-git-dir "$gitdir" "$url" "$sm_path"
286 ) ||
64394e3a 287 die "$(eval_gettext "Clone of '\$url' into submodule path '\$sm_path' failed")"
501770e1 288 fi
ea115a0d 289
6eafa6d0
JL
290 # We already are at the root of the work tree but cd_to_toplevel will
291 # resolve any symlinks that might be present in $PWD
292 a=$(cd_to_toplevel && cd "$gitdir" && pwd)/
15b3c82c 293 b=$(cd_to_toplevel && cd "$sm_path" && pwd)/
d75219b4
JL
294 # Remove all common leading directories after a sanity check
295 if test "${a#$b}" != "$a" || test "${b#$a}" != "$b"; then
296 die "$(eval_gettext "Gitdir '\$a' is part of the submodule path '\$b' or vice versa")"
297 fi
298 while test "${a%%/*}" = "${b%%/*}"
299 do
300 a=${a#*/}
301 b=${b#*/}
302 done
303 # Now chop off the trailing '/'s that were added in the beginning
304 a=${a%/}
305 b=${b%/}
306
c5bc42b9 307 # Turn each leading "*/" component into "../"
6a066230
JH
308 rel=$(printf '%s\n' "$b" | sed -e 's|[^/][^/]*|..|g')
309 printf '%s\n' "gitdir: $rel/$a" >"$sm_path/.git"
69c30517 310
6a066230 311 rel=$(printf '%s\n' "$a" | sed -e 's|[^/][^/]*|..|g')
d851ffb9 312 (clear_local_git_env; cd "$sm_path" && GIT_WORK_TREE=. git config core.worktree "$rel/$b")
33aa6fff
LH
313}
314
862ae6cd
RS
315isnumber()
316{
317 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
318}
319
ecda0723
SV
320#
321# Add a new submodule to the working tree, .gitmodules and the index
322#
ec05df35 323# $@ = repo path
ecda0723
SV
324#
325# optional branch is stored in global branch variable
326#
23a485e3 327cmd_add()
ecda0723 328{
5c08dbbd 329 # parse $args after "submodule ... add".
091a6eb0 330 reference_path=
5c08dbbd
JH
331 while test $# -ne 0
332 do
333 case "$1" in
334 -b | --branch)
335 case "$2" in '') usage ;; esac
336 branch=$2
337 shift
338 ;;
d27b876b
JL
339 -f | --force)
340 force=$1
341 ;;
5c08dbbd 342 -q|--quiet)
2e6a30ef 343 GIT_QUIET=1
5c08dbbd 344 ;;
d92a3959
MT
345 --reference)
346 case "$2" in '') usage ;; esac
091a6eb0 347 reference_path=$2
d92a3959
MT
348 shift
349 ;;
350 --reference=*)
091a6eb0 351 reference_path="${1#--reference=}"
d92a3959 352 ;;
73b0898d
JL
353 --name)
354 case "$2" in '') usage ;; esac
355 custom_name=$2
356 shift
357 ;;
275cd184
FG
358 --depth)
359 case "$2" in '') usage ;; esac
360 depth="--depth=$2"
361 shift
362 ;;
363 --depth=*)
364 depth=$1
365 ;;
5c08dbbd
JH
366 --)
367 shift
368 break
369 ;;
370 -*)
371 usage
372 ;;
373 *)
374 break
375 ;;
376 esac
377 shift
378 done
379
091a6eb0
JK
380 if test -n "$reference_path"
381 then
382 is_absolute_path "$reference_path" ||
383 reference_path="$wt_prefix$reference_path"
384
385 reference="--reference=$reference_path"
386 fi
387
ecda0723 388 repo=$1
64394e3a 389 sm_path=$2
ecda0723 390
64394e3a 391 if test -z "$sm_path"; then
6a066230 392 sm_path=$(printf '%s\n' "$repo" |
1414e578
JL
393 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
394 fi
395
496eeeb1 396 if test -z "$repo" || test -z "$sm_path"; then
ecda0723
SV
397 usage
398 fi
399
091a6eb0
JK
400 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
401
ec05df35
ML
402 # assure repo is absolute or relative to parent
403 case "$repo" in
404 ./*|../*)
091a6eb0
JK
405 test -z "$wt_prefix" ||
406 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
407
ec05df35
ML
408 # dereference source url relative to parent's url
409 realrepo=$(resolve_relative_url "$repo") || exit
410 ;;
411 *:*|/*)
412 # absolute url
413 realrepo=$repo
414 ;;
415 *)
497ee872 416 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
ec05df35
ML
417 ;;
418 esac
419
db75ada5
MG
420 # normalize path:
421 # multiple //; leading ./; /./; /../; trailing /
64394e3a 422 sm_path=$(printf '%s/\n' "$sm_path" |
db75ada5
MG
423 sed -e '
424 s|//*|/|g
425 s|^\(\./\)*||
426 s|/\./|/|g
427 :start
428 s|\([^/]*\)/\.\./||
429 tstart
430 s|/*$||
431 ')
64394e3a
RJ
432 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
433 die "$(eval_gettext "'\$sm_path' already exists in the index")"
ecda0723 434
64394e3a 435 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
d27b876b 436 then
6ff875c5 437 eval_gettextln "The following path is ignored by one of your .gitignore files:
64394e3a 438\$sm_path
6ff875c5 439Use -f if you really want to add it." >&2
d27b876b
JL
440 exit 1
441 fi
442
73b0898d
JL
443 if test -n "$custom_name"
444 then
445 sm_name="$custom_name"
446 else
447 sm_name="$sm_path"
448 fi
449
d4264ca3 450 # perhaps the path exists and is already a git repo, else clone it
64394e3a 451 if test -e "$sm_path"
d4264ca3 452 then
496eeeb1 453 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
d4264ca3 454 then
64394e3a 455 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
d4264ca3 456 else
64394e3a 457 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
d4264ca3 458 fi
c2f93917 459
d4264ca3 460 else
4b7c286e
JL
461 if test -d ".git/modules/$sm_name"
462 then
463 if test -z "$force"
464 then
465 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
466 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
467 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
468 echo >&2 " $realrepo"
469 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
470 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
471 else
472 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
473 fi
474 fi
d851ffb9
JH
475 module_clone "$sm_path" "$sm_name" "$realrepo" "$reference" "$depth" || exit
476 (
477 clear_local_git_env
478 cd "$sm_path" &&
479 # ash fails to wordsplit ${branch:+-b "$branch"...}
480 case "$branch" in
481 '') git checkout -f -q ;;
482 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
483 esac
484 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
d4264ca3 485 fi
73b0898d 486 git config submodule."$sm_name".url "$realrepo"
d4264ca3 487
64394e3a
RJ
488 git add $force "$sm_path" ||
489 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
ecda0723 490
73b0898d
JL
491 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
492 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
b9289227
TK
493 if test -n "$branch"
494 then
495 git config -f .gitmodules submodule."$sm_name".branch "$branch"
496 fi &&
31991b02 497 git add --force .gitmodules ||
64394e3a 498 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
ecda0723
SV
499}
500
19a31f9c
ML
501#
502# Execute an arbitrary command sequence in each checked out
503# submodule
504#
505# $@ = command to execute
506#
507cmd_foreach()
508{
1d5bec8b
JH
509 # parse $args after "submodule ... foreach".
510 while test $# -ne 0
511 do
512 case "$1" in
513 -q|--quiet)
514 GIT_QUIET=1
515 ;;
15fc56a8
JH
516 --recursive)
517 recursive=1
518 ;;
1d5bec8b
JH
519 -*)
520 usage
521 ;;
522 *)
523 break
524 ;;
525 esac
526 shift
527 done
528
f030c96d
ÆAB
529 toplevel=$(pwd)
530
4dca1aa6
BC
531 # dup stdin so that it can be restored when running the external
532 # command in the subshell (and a recursive call to this function)
533 exec 3<&0
534
a7b3269c 535 module_list |
64394e3a 536 while read mode sha1 stage sm_path
19a31f9c 537 do
be9d0a3a 538 die_if_unmatched "$mode"
64394e3a 539 if test -e "$sm_path"/.git
19a31f9c 540 then
091a6eb0
JK
541 displaypath=$(relative_path "$sm_path")
542 say "$(eval_gettext "Entering '\$prefix\$displaypath'")"
64394e3a 543 name=$(module_name "$sm_path")
15fc56a8 544 (
64394e3a 545 prefix="$prefix$sm_path/"
74ae1419 546 clear_local_git_env
64394e3a 547 cd "$sm_path" &&
091a6eb0
JK
548 sm_path=$(relative_path "$sm_path") &&
549 # we make $path available to scripts ...
550 path=$sm_path &&
1c4fb136
AK
551 if test $# -eq 1
552 then
553 eval "$1"
554 else
555 "$@"
556 fi &&
15fc56a8
JH
557 if test -n "$recursive"
558 then
559 cmd_foreach "--recursive" "$@"
560 fi
4dca1aa6 561 ) <&3 3<&- ||
091a6eb0 562 die "$(eval_gettext "Stopping at '\$prefix\$displaypath'; script returned non-zero status.")"
19a31f9c
ML
563 fi
564 done
565}
566
70c7ac22 567#
211b7f19 568# Register submodules in .git/config
70c7ac22
LH
569#
570# $@ = requested paths (default to all)
571#
23a485e3 572cmd_init()
70c7ac22 573{
5c08dbbd
JH
574 # parse $args after "submodule ... init".
575 while test $# -ne 0
576 do
577 case "$1" in
578 -q|--quiet)
2e6a30ef 579 GIT_QUIET=1
5c08dbbd
JH
580 ;;
581 --)
582 shift
583 break
584 ;;
585 -*)
586 usage
587 ;;
588 *)
589 break
590 ;;
591 esac
592 shift
593 done
594
a7b3269c 595 module_list "$@" |
64394e3a 596 while read mode sha1 stage sm_path
70c7ac22 597 do
be9d0a3a 598 die_if_unmatched "$mode"
64394e3a 599 name=$(module_name "$sm_path") || exit
c1c259e2 600
091a6eb0
JK
601 displaypath=$(relative_path "$sm_path")
602
c1c259e2 603 # Copy url setting when it is not set yet
2cd9de3e
JL
604 if test -z "$(git config "submodule.$name.url")"
605 then
606 url=$(git config -f .gitmodules submodule."$name".url)
607 test -z "$url" &&
091a6eb0 608 die "$(eval_gettext "No url found for submodule path '\$displaypath' in .gitmodules")"
2cd9de3e
JL
609
610 # Possibly a url relative to parent
611 case "$url" in
612 ./*|../*)
613 url=$(resolve_relative_url "$url") || exit
614 ;;
615 esac
616 git config submodule."$name".url "$url" ||
091a6eb0 617 die "$(eval_gettext "Failed to register url for submodule path '\$displaypath'")"
c1c259e2 618
091a6eb0 619 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$displaypath'")"
2cd9de3e 620 fi
70c7ac22 621
2cd9de3e 622 # Copy "update" setting when it is not set yet
ac1fbbda
JH
623 if upd="$(git config -f .gitmodules submodule."$name".update)" &&
624 test -n "$upd" &&
625 test -z "$(git config submodule."$name".update)"
626 then
627 case "$upd" in
efa8fd7e 628 checkout | rebase | merge | none)
ac1fbbda
JH
629 ;; # known modes of updating
630 *)
631 echo >&2 "warning: unknown update mode '$upd' suggested for submodule '$name'"
632 upd=none
633 ;;
634 esac
635 git config submodule."$name".update "$upd" ||
636 die "$(eval_gettext "Failed to register update mode for submodule path '\$displaypath'")"
637 fi
70c7ac22
LH
638 done
639}
640
cf419828
JL
641#
642# Unregister submodules from .git/config and remove their work tree
643#
644# $@ = requested paths (use '.' to deinit all submodules)
645#
646cmd_deinit()
647{
648 # parse $args after "submodule ... deinit".
649 while test $# -ne 0
650 do
651 case "$1" in
652 -f|--force)
653 force=$1
654 ;;
655 -q|--quiet)
656 GIT_QUIET=1
657 ;;
658 --)
659 shift
660 break
661 ;;
662 -*)
663 usage
664 ;;
665 *)
666 break
667 ;;
668 esac
669 shift
670 done
671
672 if test $# = 0
673 then
674 die "$(eval_gettext "Use '.' if you really want to deinitialize all submodules")"
675 fi
676
677 module_list "$@" |
678 while read mode sha1 stage sm_path
679 do
680 die_if_unmatched "$mode"
681 name=$(module_name "$sm_path") || exit
682
091a6eb0
JK
683 displaypath=$(relative_path "$sm_path")
684
cf419828
JL
685 # Remove the submodule work tree (unless the user already did it)
686 if test -d "$sm_path"
687 then
688 # Protect submodules containing a .git directory
689 if test -d "$sm_path/.git"
690 then
091a6eb0 691 echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
cf419828
JL
692 die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
693 fi
694
695 if test -z "$force"
696 then
7b294bf4 697 git rm -qn "$sm_path" ||
091a6eb0 698 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
cf419828 699 fi
7b294bf4 700 rm -rf "$sm_path" &&
091a6eb0
JK
701 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
702 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
cf419828
JL
703 fi
704
091a6eb0 705 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
cf419828
JL
706
707 # Remove the .git/config entries (unless the user already did it)
708 if test -n "$(git config --get-regexp submodule."$name\.")"
709 then
710 # Remove the whole section so we have a clean state when
711 # the user later decides to init this submodule again
712 url=$(git config submodule."$name".url)
713 git config --remove-section submodule."$name" 2>/dev/null &&
091a6eb0 714 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
cf419828
JL
715 fi
716 done
717}
718
70c7ac22 719#
211b7f19 720# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
721#
722# $@ = requested paths (default to all)
723#
23a485e3 724cmd_update()
70c7ac22 725{
5c08dbbd
JH
726 # parse $args after "submodule ... update".
727 while test $# -ne 0
728 do
729 case "$1" in
730 -q|--quiet)
2e6a30ef 731 GIT_QUIET=1
5c08dbbd 732 ;;
be4d2c83 733 -i|--init)
d92a3959 734 init=1
be4d2c83 735 ;;
06b1abb5
TK
736 --remote)
737 remote=1
738 ;;
31ca3ac3 739 -N|--no-fetch)
31ca3ac3
FF
740 nofetch=1
741 ;;
9db31bdf
NMC
742 -f|--force)
743 force=$1
744 ;;
ca2cedba 745 -r|--rebase)
32948425 746 update="rebase"
ca2cedba 747 ;;
d92a3959
MT
748 --reference)
749 case "$2" in '') usage ;; esac
750 reference="--reference=$2"
98dbe63d 751 shift
d92a3959
MT
752 ;;
753 --reference=*)
754 reference="$1"
d92a3959 755 ;;
42b49178 756 -m|--merge)
42b49178
JH
757 update="merge"
758 ;;
b13fd5c1 759 --recursive)
b13fd5c1
JH
760 recursive=1
761 ;;
efc5fb6a
JH
762 --checkout)
763 update="checkout"
764 ;;
275cd184
FG
765 --depth)
766 case "$2" in '') usage ;; esac
767 depth="--depth=$2"
768 shift
769 ;;
770 --depth=*)
771 depth=$1
772 ;;
5c08dbbd
JH
773 --)
774 shift
775 break
776 ;;
777 -*)
778 usage
779 ;;
780 *)
781 break
782 ;;
783 esac
98dbe63d 784 shift
5c08dbbd
JH
785 done
786
d92a3959
MT
787 if test -n "$init"
788 then
789 cmd_init "--" "$@" || return
790 fi
791
1b4735d9 792 cloned_modules=
15ffb7cd
FG
793 module_list "$@" | {
794 err=
64394e3a 795 while read mode sha1 stage sm_path
70c7ac22 796 do
be9d0a3a 797 die_if_unmatched "$mode"
313ee0d6
NMC
798 if test "$stage" = U
799 then
75bf5e60 800 echo >&2 "Skipping unmerged submodule $prefix$sm_path"
313ee0d6
NMC
801 continue
802 fi
64394e3a 803 name=$(module_name "$sm_path") || exit
5be60078 804 url=$(git config submodule."$name".url)
d851ffb9 805 branch=$(get_submodule_config "$name" branch master)
efc5fb6a
JH
806 if ! test -z "$update"
807 then
808 update_module=$update
809 else
810 update_module=$(git config submodule."$name".update)
a2aed08b
TK
811 if test -z "$update_module"
812 then
813 update_module="checkout"
814 fi
efc5fb6a
JH
815 fi
816
091a6eb0
JK
817 displaypath=$(relative_path "$prefix$sm_path")
818
d851ffb9
JH
819 if test "$update_module" = "none"
820 then
091a6eb0 821 echo "Skipping submodule '$displaypath'"
efc5fb6a 822 continue
d851ffb9 823 fi
efc5fb6a 824
211b7f19 825 if test -z "$url"
70c7ac22
LH
826 then
827 # Only mention uninitialized submodules when its
828 # path have been specified
829 test "$#" != "0" &&
091a6eb0 830 say "$(eval_gettext "Submodule path '\$displaypath' not initialized
1c2ef66f 831Maybe you want to use 'update --init'?")"
211b7f19
LH
832 continue
833 fi
834
496eeeb1 835 if ! test -d "$sm_path"/.git && ! test -f "$sm_path"/.git
211b7f19 836 then
d851ffb9 837 module_clone "$sm_path" "$name" "$url" "$reference" "$depth" || exit
1b4735d9 838 cloned_modules="$cloned_modules;$name"
bf2d8246
LH
839 subsha1=
840 else
64394e3a 841 subsha1=$(clear_local_git_env; cd "$sm_path" &&
5be60078 842 git rev-parse --verify HEAD) ||
091a6eb0 843 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
70c7ac22 844 fi
211b7f19 845
06b1abb5
TK
846 if test -n "$remote"
847 then
848 if test -z "$nofetch"
849 then
850 # Fetch remote before determining tracking $sha1
851 (clear_local_git_env; cd "$sm_path" && git-fetch) ||
852 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
853 fi
854 remote_name=$(clear_local_git_env; cd "$sm_path" && get_default_remote)
855 sha1=$(clear_local_git_env; cd "$sm_path" &&
856 git rev-parse --verify "${remote_name}/${branch}") ||
857 die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
858 fi
859
496eeeb1 860 if test "$subsha1" != "$sha1" || test -n "$force"
70c7ac22 861 then
9db31bdf
NMC
862 subforce=$force
863 # If we don't already have a -f flag and the submodule has never been checked out
496eeeb1 864 if test -z "$subsha1" && test -z "$force"
b9b378a0 865 then
9db31bdf 866 subforce="-f"
b9b378a0 867 fi
31ca3ac3
FF
868
869 if test -z "$nofetch"
870 then
e5f522d6
JL
871 # Run fetch only if $sha1 isn't present or it
872 # is not reachable from a ref.
64394e3a 873 (clear_local_git_env; cd "$sm_path" &&
f5799e05 874 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
e5f522d6 875 test -z "$rev") || git-fetch)) ||
091a6eb0 876 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
31ca3ac3
FF
877 fi
878
1b4735d9
SO
879 # Is this something we just cloned?
880 case ";$cloned_modules;" in
881 *";$name;"*)
882 # then there is no local change to integrate
d851ffb9 883 update_module=checkout ;;
1b4735d9
SO
884 esac
885
877449c1 886 must_die_on_failure=
32948425 887 case "$update_module" in
a2aed08b
TK
888 checkout)
889 command="git checkout $subforce -q"
890 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
891 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
892 ;;
32948425
JH
893 rebase)
894 command="git rebase"
091a6eb0
JK
895 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
896 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
877449c1 897 must_die_on_failure=yes
32948425 898 ;;
42b49178
JH
899 merge)
900 command="git merge"
091a6eb0
JK
901 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
902 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
877449c1 903 must_die_on_failure=yes
42b49178 904 ;;
6cb5728c
CP
905 !*)
906 command="${update_module#!}"
907 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$prefix\$sm_path'")"
908 say_msg="$(eval_gettext "Submodule path '\$prefix\$sm_path': '\$command \$sha1'")"
909 must_die_on_failure=yes
910 ;;
32948425 911 *)
a2aed08b 912 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
32948425 913 esac
70c7ac22 914
64394e3a 915 if (clear_local_git_env; cd "$sm_path" && $command "$sha1")
15ffb7cd 916 then
ff968f03 917 say "$say_msg"
877449c1
JH
918 elif test -n "$must_die_on_failure"
919 then
ff968f03 920 die_with_status 2 "$die_msg"
15ffb7cd 921 else
ff968f03 922 err="${err};$die_msg"
877449c1 923 continue
15ffb7cd 924 fi
70c7ac22 925 fi
b13fd5c1
JH
926
927 if test -n "$recursive"
928 then
75bf5e60
WE
929 (
930 prefix="$prefix$sm_path/"
931 clear_local_git_env
932 cd "$sm_path" &&
36141282 933 eval cmd_update
75bf5e60 934 )
15ffb7cd
FG
935 res=$?
936 if test $res -gt 0
937 then
091a6eb0 938 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
15ffb7cd
FG
939 if test $res -eq 1
940 then
ff968f03 941 err="${err};$die_msg"
15ffb7cd
FG
942 continue
943 else
ff968f03 944 die_with_status $res "$die_msg"
15ffb7cd
FG
945 fi
946 fi
b13fd5c1 947 fi
70c7ac22 948 done
15ffb7cd
FG
949
950 if test -n "$err"
951 then
952 OIFS=$IFS
953 IFS=';'
954 for e in $err
955 do
956 if test -n "$e"
957 then
958 echo >&2 "$e"
959 fi
960 done
961 IFS=$OIFS
962 exit 1
963 fi
964 }
70c7ac22
LH
965}
966
bffe71f4
EM
967set_name_rev () {
968 revname=$( (
74ae1419 969 clear_local_git_env
bffe71f4 970 cd "$1" && {
5be60078
JH
971 git describe "$2" 2>/dev/null ||
972 git describe --tags "$2" 2>/dev/null ||
f669ac0b
ML
973 git describe --contains "$2" 2>/dev/null ||
974 git describe --all --always "$2"
bffe71f4
EM
975 }
976 ) )
977 test -z "$revname" || revname=" ($revname)"
978}
28f9af5d
PY
979#
980# Show commit summary for submodules in index or working tree
981#
982# If '--cached' is given, show summary between index and given commit,
983# or between working tree and given commit
984#
985# $@ = [commit (default 'HEAD'),] requested paths (default all)
986#
987cmd_summary() {
f2dc06a3 988 summary_limit=-1
d0f64dd4 989 for_status=
1c244f6e 990 diff_cmd=diff-index
f2dc06a3 991
28f9af5d
PY
992 # parse $args after "submodule ... summary".
993 while test $# -ne 0
994 do
995 case "$1" in
996 --cached)
997 cached="$1"
998 ;;
1c244f6e
JL
999 --files)
1000 files="$1"
1001 ;;
d0f64dd4
PY
1002 --for-status)
1003 for_status="$1"
1004 ;;
f2dc06a3 1005 -n|--summary-limit)
862ae6cd
RS
1006 summary_limit="$2"
1007 isnumber "$summary_limit" || usage
f2dc06a3
PY
1008 shift
1009 ;;
862ae6cd
RS
1010 --summary-limit=*)
1011 summary_limit="${1#--summary-limit=}"
1012 isnumber "$summary_limit" || usage
1013 ;;
28f9af5d
PY
1014 --)
1015 shift
1016 break
1017 ;;
1018 -*)
1019 usage
1020 ;;
1021 *)
1022 break
1023 ;;
1024 esac
1025 shift
1026 done
bffe71f4 1027
f2dc06a3
PY
1028 test $summary_limit = 0 && return
1029
3deea89c 1030 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
1031 then
1032 head=$rev
caa9c3ca 1033 test $# = 0 || shift
496eeeb1 1034 elif test -z "$1" || test "$1" = "HEAD"
3deea89c 1035 then
14e940d7
JH
1036 # before the first commit: compare with an empty tree
1037 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 1038 test -z "$1" || shift
28f9af5d 1039 else
3deea89c 1040 head="HEAD"
28f9af5d
PY
1041 fi
1042
1c244f6e
JL
1043 if [ -n "$files" ]
1044 then
1045 test -n "$cached" &&
465d6a00 1046 die "$(gettext "The --cached option cannot be used with the --files option")"
1c244f6e
JL
1047 diff_cmd=diff-files
1048 head=
1049 fi
1050
28f9af5d 1051 cd_to_toplevel
091a6eb0 1052 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
28f9af5d 1053 # Get modified modules cared by user
18076502 1054 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 1055 sane_egrep '^:([0-7]* )?160000' |
2be94509 1056 while read mod_src mod_dst sha1_src sha1_dst status sm_path
28f9af5d
PY
1057 do
1058 # Always show modules deleted or type-changed (blob<->module)
496eeeb1
EP
1059 if test "$status" = D || test "$status" = T
1060 then
6a066230 1061 printf '%s\n' "$sm_path"
496eeeb1
EP
1062 continue
1063 fi
927b26f8 1064 # Respect the ignore setting for --for-status.
1065 if test -n "$for_status"
1066 then
1067 name=$(module_name "$sm_path")
1068 ignore_config=$(get_submodule_config "$name" ignore none)
496eeeb1 1069 test $status != A && test $ignore_config = all && continue
927b26f8 1070 fi
28f9af5d 1071 # Also show added or modified modules which are checked out
2be94509 1072 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
6a066230 1073 printf '%s\n' "$sm_path"
28f9af5d
PY
1074 done
1075 )
1cb639e6 1076
d0f64dd4
PY
1077 test -z "$modules" && return
1078
18076502 1079 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 1080 sane_egrep '^:([0-7]* )?160000' |
1cb639e6
PY
1081 cut -c2- |
1082 while read mod_src mod_dst sha1_src sha1_dst status name
1083 do
1084 if test -z "$cached" &&
1085 test $sha1_dst = 0000000000000000000000000000000000000000
1086 then
1087 case "$mod_dst" in
1088 160000)
1089 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
1090 ;;
1091 100644 | 100755 | 120000)
1092 sha1_dst=$(git hash-object $name)
1093 ;;
1094 000000)
1095 ;; # removed
1096 *)
1097 # unexpected type
6ff875c5 1098 eval_gettextln "unexpected mode \$mod_dst" >&2
1cb639e6
PY
1099 continue ;;
1100 esac
1101 fi
1102 missing_src=
1103 missing_dst=
1104
1105 test $mod_src = 160000 &&
30353a40 1106 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
1107 missing_src=t
1108
1109 test $mod_dst = 160000 &&
30353a40 1110 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 1111 missing_dst=t
bffe71f4 1112
091a6eb0
JK
1113 display_name=$(relative_path "$name")
1114
1cb639e6
PY
1115 total_commits=
1116 case "$missing_src,$missing_dst" in
1117 t,)
091a6eb0 1118 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1cb639e6
PY
1119 ;;
1120 ,t)
091a6eb0 1121 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1cb639e6
PY
1122 ;;
1123 t,t)
091a6eb0 1124 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1cb639e6
PY
1125 ;;
1126 *)
1127 errmsg=
1128 total_commits=$(
496eeeb1 1129 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6
PY
1130 then
1131 range="$sha1_src...$sha1_dst"
1132 elif test $mod_src = 160000
1133 then
1134 range=$sha1_src
1135 else
1136 range=$sha1_dst
1137 fi
1138 GIT_DIR="$name/.git" \
b0e621ad 1139 git rev-list --first-parent $range -- | wc -l
1cb639e6 1140 )
eed35595 1141 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
1142 ;;
1143 esac
1144
1145 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
1146 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
1147 if test $status = T
1148 then
b3e73449
ÆAB
1149 blob="$(gettext "blob")"
1150 submodule="$(gettext "submodule")"
1cb639e6
PY
1151 if test $mod_dst = 160000
1152 then
091a6eb0 1153 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1cb639e6 1154 else
091a6eb0 1155 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1cb639e6
PY
1156 fi
1157 else
091a6eb0 1158 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1cb639e6
PY
1159 fi
1160 if test -n "$errmsg"
1161 then
1162 # Don't give error msg for modification whose dst is not submodule
1163 # i.e. deleted or changed to blob
1164 test $mod_dst = 160000 && echo "$errmsg"
1165 else
496eeeb1 1166 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6 1167 then
f2dc06a3
PY
1168 limit=
1169 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 1170 GIT_DIR="$name/.git" \
f2dc06a3 1171 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
1172 --first-parent $sha1_src...$sha1_dst
1173 elif test $mod_dst = 160000
1174 then
1175 GIT_DIR="$name/.git" \
1176 git log --pretty='format: > %s' -1 $sha1_dst
1177 else
1178 GIT_DIR="$name/.git" \
1179 git log --pretty='format: < %s' -1 $sha1_src
1180 fi
1181 echo
1182 fi
1183 echo
3ba7407b 1184 done
28f9af5d 1185}
70c7ac22 1186#
941987a5 1187# List all submodules, prefixed with:
70c7ac22
LH
1188# - submodule not initialized
1189# + different revision checked out
1190#
1191# If --cached was specified the revision in the index will be printed
1192# instead of the currently checked out revision.
1193#
1194# $@ = requested paths (default to all)
1195#
23a485e3 1196cmd_status()
70c7ac22 1197{
5c08dbbd
JH
1198 # parse $args after "submodule ... status".
1199 while test $# -ne 0
1200 do
1201 case "$1" in
1202 -q|--quiet)
2e6a30ef 1203 GIT_QUIET=1
5c08dbbd
JH
1204 ;;
1205 --cached)
1206 cached=1
1207 ;;
64b19ffe
JH
1208 --recursive)
1209 recursive=1
1210 ;;
5c08dbbd
JH
1211 --)
1212 shift
1213 break
1214 ;;
1215 -*)
1216 usage
1217 ;;
1218 *)
1219 break
1220 ;;
1221 esac
1222 shift
1223 done
1224
a7b3269c 1225 module_list "$@" |
64394e3a 1226 while read mode sha1 stage sm_path
70c7ac22 1227 do
be9d0a3a 1228 die_if_unmatched "$mode"
64394e3a 1229 name=$(module_name "$sm_path") || exit
5be60078 1230 url=$(git config submodule."$name".url)
091a6eb0 1231 displaypath=$(relative_path "$prefix$sm_path")
313ee0d6
NMC
1232 if test "$stage" = U
1233 then
1234 say "U$sha1 $displaypath"
1235 continue
1236 fi
496eeeb1
EP
1237 if test -z "$url" ||
1238 {
1239 ! test -d "$sm_path"/.git &&
1240 ! test -f "$sm_path"/.git
1241 }
70c7ac22 1242 then
64b19ffe 1243 say "-$sha1 $displaypath"
70c7ac22
LH
1244 continue;
1245 fi
64394e3a 1246 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
70c7ac22 1247 then
b545cd15 1248 set_name_rev "$sm_path" "$sha1"
64b19ffe 1249 say " $sha1 $displaypath$revname"
70c7ac22
LH
1250 else
1251 if test -z "$cached"
1252 then
64394e3a 1253 sha1=$(clear_local_git_env; cd "$sm_path" && git rev-parse --verify HEAD)
70c7ac22 1254 fi
b545cd15 1255 set_name_rev "$sm_path" "$sha1"
64b19ffe
JH
1256 say "+$sha1 $displaypath$revname"
1257 fi
1258
1259 if test -n "$recursive"
1260 then
1261 (
1262 prefix="$displaypath/"
74ae1419 1263 clear_local_git_env
64394e3a 1264 cd "$sm_path" &&
e15bec0e 1265 eval cmd_status
64b19ffe 1266 ) ||
64394e3a 1267 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
70c7ac22
LH
1268 fi
1269 done
1270}
2327f61e
DA
1271#
1272# Sync remote urls for submodules
1273# This makes the value for remote.$remote.url match the value
1274# specified in .gitmodules.
1275#
1276cmd_sync()
1277{
1278 while test $# -ne 0
1279 do
1280 case "$1" in
1281 -q|--quiet)
2e6a30ef 1282 GIT_QUIET=1
2327f61e
DA
1283 shift
1284 ;;
82f49f29
PH
1285 --recursive)
1286 recursive=1
1287 shift
1288 ;;
2327f61e
DA
1289 --)
1290 shift
1291 break
1292 ;;
1293 -*)
1294 usage
1295 ;;
1296 *)
1297 break
1298 ;;
1299 esac
1300 done
1301 cd_to_toplevel
1302 module_list "$@" |
64394e3a 1303 while read mode sha1 stage sm_path
2327f61e 1304 do
be9d0a3a 1305 die_if_unmatched "$mode"
64394e3a 1306 name=$(module_name "$sm_path")
2327f61e 1307 url=$(git config -f .gitmodules --get submodule."$name".url)
baede9f8
JH
1308
1309 # Possibly a url relative to parent
1310 case "$url" in
1311 ./*|../*)
967b2c66
JS
1312 # rewrite foo/bar as ../.. to find path from
1313 # submodule work tree to superproject work tree
6a066230 1314 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
967b2c66
JS
1315 # guarantee a trailing /
1316 up_path=${up_path%/}/ &&
1317 # path from submodule work tree to submodule origin repo
1318 sub_origin_url=$(resolve_relative_url "$url" "$up_path") &&
1319 # path from superproject work tree to submodule origin repo
1320 super_config_url=$(resolve_relative_url "$url") || exit
1321 ;;
1322 *)
1323 sub_origin_url="$url"
1324 super_config_url="$url"
baede9f8
JH
1325 ;;
1326 esac
1327
ccee6086 1328 if git config "submodule.$name.url" >/dev/null 2>/dev/null
2327f61e 1329 then
091a6eb0
JK
1330 displaypath=$(relative_path "$prefix$sm_path")
1331 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
967b2c66 1332 git config submodule."$name".url "$super_config_url"
ccee6086 1333
64394e3a 1334 if test -e "$sm_path"/.git
ccee6086
JH
1335 then
1336 (
1337 clear_local_git_env
64394e3a 1338 cd "$sm_path"
ccee6086 1339 remote=$(get_default_remote)
967b2c66 1340 git config remote."$remote".url "$sub_origin_url"
82f49f29
PH
1341
1342 if test -n "$recursive"
1343 then
1344 prefix="$prefix$sm_path/"
1345 eval cmd_sync
1346 fi
ccee6086
JH
1347 )
1348 fi
2327f61e
DA
1349 fi
1350 done
1351}
70c7ac22 1352
5c08dbbd
JH
1353# This loop parses the command line arguments to find the
1354# subcommand name to dispatch. Parsing of the subcommand specific
1355# options are primarily done by the subcommand implementations.
1356# Subcommand specific options such as --branch and --cached are
1357# parsed here as well, for backward compatibility.
1358
1359while test $# != 0 && test -z "$command"
70c7ac22
LH
1360do
1361 case "$1" in
cf419828 1362 add | foreach | init | deinit | update | status | summary | sync)
5c08dbbd 1363 command=$1
70c7ac22
LH
1364 ;;
1365 -q|--quiet)
2e6a30ef 1366 GIT_QUIET=1
70c7ac22 1367 ;;
ecda0723
SV
1368 -b|--branch)
1369 case "$2" in
1370 '')
1371 usage
1372 ;;
1373 esac
1374 branch="$2"; shift
1375 ;;
70c7ac22 1376 --cached)
28f9af5d 1377 cached="$1"
70c7ac22
LH
1378 ;;
1379 --)
1380 break
1381 ;;
1382 -*)
1383 usage
1384 ;;
1385 *)
1386 break
1387 ;;
1388 esac
1389 shift
1390done
1391
5c08dbbd 1392# No command word defaults to "status"
af9c9f97
RR
1393if test -z "$command"
1394then
1395 if test $# = 0
1396 then
1397 command=status
1398 else
1399 usage
1400 fi
1401fi
5c08dbbd
JH
1402
1403# "-b branch" is accepted only by "add"
1404if test -n "$branch" && test "$command" != add
1405then
ecda0723 1406 usage
5c08dbbd
JH
1407fi
1408
28f9af5d 1409# "--cached" is accepted only by "status" and "summary"
496eeeb1 1410if test -n "$cached" && test "$command" != status && test "$command" != summary
5c08dbbd 1411then
70c7ac22 1412 usage
5c08dbbd
JH
1413fi
1414
1415"cmd_$command" "$@"